<?php 
 


$servername = "localhost";
$username = "databaseusername";
$password = "databasepassword";
$dbname = "databasename";
 
try {
    $db = new PDO("mysql:host=$servername;dbname=$dbname;charset=utf8", $username, $password);
    $db->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
} catch (PDOException $e) {
    echo "Veritabanına bağlanırken hata oluştu: " . $e->getMessage();
}


if (!isset($_SERVER['PHP_AUTH_USER'])) {
    header('WWW-Authenticate: Basic realm="My Realm"');
    header('HTTP/1.0 401 Unauthorized');
    echo 'Authorization required';
    exit;
} else {
    $auth_user = $_SERVER['PHP_AUTH_USER'];
    $auth_pass = $_SERVER['PHP_AUTH_PW']; 
}
  
function userControl($user,$pass)
{
    global $db;  
	$query = "SELECT * FROM users WHERE username = :username"; 
    $stmt = $db->prepare($query);
    $stmt->execute(array(':username' => $user));
    $result = $stmt->fetch(PDO::FETCH_ASSOC); 
	
	if (!$result || !password_verify($pass, $result['password'])) {
		return false;
	} else {
		return $result["id"]; 
	}
}

$controlUser = userControl($auth_user, $auth_pass);
if(!$controlUser){ 
     echo 'Wrong user or pass'; 
	 exit;
}
function langs($id = 0)
{
    global $db; 
    if ($id == 0) {
        $query = "SELECT * FROM languages";
    } else {
        $query = "SELECT * FROM languages WHERE id = $id";
    }
    $stmt = $db->prepare($query);
    $stmt->execute();
    $result = $stmt->fetchAll(PDO::FETCH_ASSOC);
    if ($id == 0) {
        return $result;
    } else {
        return $result[0];
    }
}
$lang_id=0;

$langs = langs();
 
foreach ($langs as $lang) {
    if (strpos($_SERVER['REQUEST_URI'], "/meepressgpt/".$lang['short_form']) !== false) {
        $lang_id = $lang['id']; 
        break;
    }
}

function SlugOlustur($metin)
{
    $slug = mb_strtolower($metin, 'UTF-8'); // Küçük harflere çevirin 
    $slug = preg_replace('/\s+/', '-', $slug); // Boşlukları tire ile değiştirin 
    $turkce_karakterler = array('ç', 'ğ', 'ı', 'ö', 'ş', 'ü');
    $ingilizce_karakterler = array('c', 'g', 'i', 'o', 's', 'u');
    $slug = str_replace($turkce_karakterler, $ingilizce_karakterler, $slug); // Türkçe karakterleri ingilizce karakterlere dönüştürün 
    $slug = preg_replace('/[^a-z0-9\-]/', '', $slug); // Alfanumerik ve tire karakterleri dışındakileri kaldırın 
    $slug = trim($slug, '-');
    return $slug;
}

function kaydet($url, $slug)
{
    $image = file_get_contents($url); // URL'den görseli al 
    $file_path = 'uploads/images/' . $slug . '.jpg'; // Kaydedilecek dosya yolu 
    file_put_contents($file_path, $image); // Görseli kaydet 
    return $file_path;
}

if ($_GET["rest_route"] == "/wp/v2/categories") {


    $perPage = isset($_GET["per_page"]) ? intval($_GET["per_page"]) : 10;
    $page = isset($_GET["page"]) ? intval($_GET["page"]) : 1;
    $offset = ($page - 1) * $perPage;
	 
    $query = "SELECT id, name FROM categories ".($lang_id!=0?" where lang_id=".$lang_id:"")." LIMIT $perPage OFFSET $offset";
    $stmt = $db->prepare($query);
    $stmt->execute();
    $result = $stmt->fetchAll(PDO::FETCH_ASSOC);

    $jsonArray = [];

    foreach ($result as $row) {
        $jsonArray[] = [
            "id" => $row['id'],
            "count" => 0,
            "description" => "",
            "link" => $siteAdress . "/category/" . $row['name'] . "/",
            "name" => $row['name'],
            "slug" => strtolower($row['name']),
            "taxonomy" => "category",
            "parent" => 0,
            "meta" => [],
            "acf" => [],
            "_links" => [
                "self" => [
                    [
                        "href" => $siteAdress . "/wp-json/wp/v2/categories/" . $row['id']
                    ]
                ],
                "collection" => [
                    [
                        "href" =>  $siteAdress . "/wp-json/wp/v2/categories"
                    ]
                ],
                "about" => [
                    [
                        "href" =>  $siteAdress . "/wp-json/wp/v2/taxonomies/category"
                    ]
                ],
                "wp:post_type" => [
                    [
                        "href" => $siteAdress . "/wp-json/wp/v2/posts?categories=" . $row['id']
                    ]
                ],
                "curies" => [
                    [
                        "name" => "wp",
                        "href" => "https://api.w.org/{rel}",
                        "templated" => true
                    ]
                ]
            ]
        ];
    }

    $json = json_encode($jsonArray, JSON_UNESCAPED_UNICODE);
    echo $json;
} else if ($_GET["rest_route"] == "/wp/v2/media") {
    $uploadDirectory = 'uploads/images/';
    if (!file_exists($uploadDirectory)) {
        mkdir($uploadDirectory, 0777, true);
    }
    $file = $_FILES['file'];
    $fileName = basename($file['name']);
    $uploadPath = $uploadDirectory . rand(999, 9999) . "_" . $fileName;
    if (move_uploaded_file($file['tmp_name'], $uploadPath)) {
        $response = [
            'id' => $uploadPath,
            'status' => 'success',
            'message' => 'Dosya başarıyla yüklendi.',
            'file_path' => $uploadPath
        ];
    } else { 
        $response = [
            'status' => 'error',
            'message' => 'Dosya yüklenirken bir hata oluştu.'
        ];
    }
    header('Content-Type: application/json');
    echo json_encode($response);
} elseif (strpos($_SERVER['REQUEST_URI'], "/wp/v2/media/") !== false) {
    $url = explode("media/", $_SERVER['REQUEST_URI'])[1];
    echo '{"guid":{"rendered":"/' . $url . '"}}';
} else {

    $json_data = file_get_contents('php://input');
    $data = json_decode($json_data, true);


    if ($data['title'] && $data['content']) {
		
        try {
            $query = "INSERT INTO posts (title, content, created_at, status, resim_aciklamasi, baslik_kisayolurl, category_id, user_id, resim_buyuk, resim_gercek, resim_slayt, resim_orta, resim_ufak,resim_pando,post_type,taslak_olarakkaydet,lang_id) 
          VALUES (:title, :content, :created_at, :post_status, :resim_aciklamasi, :baslik_kisayolurl, :category_id, :user_id, :resim_buyuk, :resim_gercek, :resim_slayt, :resim_orta, :resim_ufak,:resim_pando,:post_type,:taslak_olarakkaydet,:lang_id)";

            $params = array(
                ':title' => $data['title'],
                ':content' => $data['content'],
                ':created_at' => $data["date"],
                ':post_status' => $data["status"] == "draft" ? 0 : 1,
                ':resim_aciklamasi' => $data['title'],
                ':baslik_kisayolurl' => SlugOlustur($data['title']),
                ':category_id' => $data["categories"][0],
                ':user_id' => $controlUser,
                ':post_type' => "article",
                ':resim_buyuk' => $data['featured_media'],
                ':resim_gercek' => $data['featured_media'],
                ':resim_slayt' => $data['featured_media'],
                ':resim_orta' => $data['featured_media'],
                ':resim_ufak' => $data['featured_media'],
                'resim_pando' => explode(".", $data['featured_media'])[1],
				':taslak_olarakkaydet' => (strtotime($data["date"]) > strtotime(date('Y-m-d H:i:s')) ? 1 : 0),
				':lang_id'=>$lang_id
            );
            $stmt = $db->prepare($query);
            $veri = $stmt->execute($params);

            echo 'İçerik başarıyla eklendi.' .  $veri;
        } catch (PDOException $e) {
            echo 'Veritabanı hatası: ' . $e->getMessage();
        }
    }
}
